!!ARBfp1.0

OPTION ARB_precision_hint_nicest;

PARAM lcolor=program.local[0];   # light color
PARAM fl_onoff=program.local[1]; # flashlight on/off

TEMP bac,lmc,flc,diffuse,d1,d2;
TEMP tex_normal,dir,light_dir;

TEX bac,fragment.texcoord[0],texture[0],2D;        # base color
TEX lmc,fragment.texcoord[1],texture[2],2D;        # lightmap color
TXP flc,fragment.texcoord[2],texture[3],2D;        # flashlight color

TEX tex_normal,fragment.texcoord[0],texture[1],2D; # normalmap color
MAD tex_normal,tex_normal,2.0,-1.0;                # result=tex_normal*2.0-1.0

DP3 dir.w,fragment.texcoord[3],fragment.texcoord[3]; # result.w=a^2+b^2+c^2
RSQ dir.w,dir.w;                                     # result.w=1/sqrt(a^2+b^2+c^2)
MUL light_dir,fragment.texcoord[3],dir.w;            # normalize
RCP dir.w,dir.w;                                     # result.w=1/a
MAD_SAT dir.w,dir.w,-0.04,1.0;                       # light1 attenuation

DP3_SAT d1,tex_normal,light_dir;
MUL d1,d1,dir.w;

DP3 dir.w,fragment.texcoord[4],fragment.texcoord[4]; # result.w=a^2+b^2+c^2
RSQ dir.w,dir.w;                                     # result.w=1/sqrt(a^2+b^2+c^2)
MUL light_dir,fragment.texcoord[4],dir.w;            # normalize
RCP dir.w,dir.w;                                     # result.w=1/a
MAD_SAT dir.w,dir.w,-0.04,1.0;                       # light2 attenuation

DP3_SAT d2,tex_normal,light_dir;
MUL d2,d2,dir.w;

ADD_SAT diffuse,d1,d2;        # diffuse sum light1+light2

MUL diffuse,diffuse,lcolor;   # diffuse*=light color
MUL diffuse,diffuse,2.0;
MUL diffuse,diffuse,lmc;      # diffuse*=lightmap color
MUL flc,flc,fl_onoff.x;
ADD diffuse,diffuse,flc;      # diffuse+=flashlight color
MUL result.color,diffuse,bac; # result.color=diffuse*base color

#MOV result.color,bac;

END